class RevisionVersionHistoryTest

Same name in this branch
  1. main core/tests/Drupal/FunctionalTests/Entity/RevisionVersionHistoryTest.php \Drupal\FunctionalTests\Entity\RevisionVersionHistoryTest
Same name and namespace in other branches
  1. 11.x core/tests/Drupal/FunctionalTests/Entity/RevisionVersionHistoryTest.php \Drupal\FunctionalTests\Entity\RevisionVersionHistoryTest
  2. 10 core/tests/Drupal/FunctionalTests/Entity/RevisionVersionHistoryTest.php \Drupal\FunctionalTests\Entity\RevisionVersionHistoryTest

Tests version history page.

Attributes

#[CoversClass(VersionHistoryController::class)] #[Group('Entity')] #[RunTestsInSeparateProcesses]

Hierarchy

Expanded class hierarchy of RevisionVersionHistoryTest

File

core/tests/Drupal/KernelTests/Core/Entity/RevisionVersionHistoryTest.php, line 21

Namespace

Drupal\KernelTests\Core\Entity
View source
class RevisionVersionHistoryTest extends KernelTestBase {
  use UserCreationTrait {
    createUser as drupalCreateUser;
  }
  
  /**
   * {@inheritdoc}
   */
  protected static $modules = [
    'entity_test',
    'entity_test_revlog',
    'user',
    'system',
  ];
  
  /**
   * {@inheritdoc}
   */
  protected function setUp() : void {
    parent::setUp();
    $this->installEntitySchema('entity_test_rev');
    $this->installEntitySchema('entity_test_revlog');
    $this->installEntitySchema('user');
    $this->installConfig([
      'system',
    ]);
  }
  
  /**
   * Test all revisions appear, in order of revision creation.
   */
  public function testOrder() : void {
    /** @var \Drupal\entity_test_revlog\Entity\EntityTestWithRevisionLog $entity */
    $entity = EntityTestWithRevisionLog::create([
      'type' => 'entity_test_revlog',
    ]);
    // Need label to be able to assert order.
    $entity->setName('view all revisions');
    $user = $this->drupalCreateUser([], 'first revision');
    $entity->setRevisionUser($user);
    $entity->setNewRevision();
    $entity->save();
    $entity->setNewRevision();
    $user = $this->drupalCreateUser([], 'second revision');
    $entity->setRevisionUser($user);
    $entity->save();
    $entity->setNewRevision();
    $user = $this->drupalCreateUser([], 'third revision');
    $entity->setRevisionUser($user);
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', 3);
    // Order is newest to oldest revision by creation order.
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', 'third revision');
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(2)', 'second revision');
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(3)', 'first revision');
  }
  
  /**
   * Test current revision is indicated.
   *
   * @legacy-covers \Drupal\Core\Entity\Controller\VersionHistoryController::revisionOverview
   */
  public function testCurrentRevision() : void {
    /** @var \Drupal\entity_test\Entity\EntityTestRev $entity */
    $entity = EntityTestRev::create([
      'type' => 'entity_test_rev',
    ]);
    // Need label to be able to assert order.
    $entity->setName('view all revisions');
    $entity->setNewRevision();
    $entity->save();
    $entity->setNewRevision();
    $entity->save();
    $entity->setNewRevision();
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', 3);
    // Current revision text is found on the latest revision row.
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', 'Current revision');
    $this->assertSession()
      ->elementTextNotContains('css', 'table tbody tr:nth-child(2)', 'Current revision');
    $this->assertSession()
      ->elementTextNotContains('css', 'table tbody tr:nth-child(3)', 'Current revision');
    // Current revision row has 'revision-current' class.
    $this->assertSession()
      ->elementAttributeContains('css', 'table tbody tr:nth-child(1)', 'class', 'revision-current');
  }
  
  /**
   * Test description with entity implementing revision log.
   *
   * @legacy-covers ::getRevisionDescription
   */
  public function testDescriptionRevLog() : void {
    /** @var \Drupal\entity_test_revlog\Entity\EntityTestWithRevisionLog $entity */
    $entity = EntityTestWithRevisionLog::create([
      'type' => 'entity_test_revlog',
    ]);
    $entity->setName('view all revisions');
    $user = $this->drupalCreateUser([], $this->randomMachineName());
    $entity->setRevisionUser($user);
    $entity->setRevisionCreationTime((new \DateTime('2 February 2013 4:00:00pm'))->getTimestamp());
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', '2 Feb 2013 - 16:00');
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', $user->getAccountName());
  }
  
  /**
   * Test description with entity implementing revision log, with empty values.
   *
   * @legacy-covers ::getRevisionDescription
   */
  public function testDescriptionRevLogNullValues() : void {
    $this->installConfig([
      'user',
    ]);
    $entity = EntityTestWithRevisionLog::create([
      'type' => 'entity_test_revlog',
    ]);
    $entity->setName('view all revisions')
      ->save();
    // Check entity values are still null after saving; they did not receive
    // values from currentUser or some other global context.
    $this->assertNull($entity->getRevisionUser());
    $this->assertNull($entity->getRevisionUserId());
    $this->assertNull($entity->getRevisionLogMessage());
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', 'by Anonymous (not verified)');
  }
  
  /**
   * Test description with entity, without revision log, no label access.
   *
   * @legacy-covers ::getRevisionDescription
   */
  public function testDescriptionNoRevLogNoLabelAccess() : void {
    /** @var \Drupal\entity_test\Entity\EntityTestRev $entity */
    $entity = EntityTestRev::create([
      'type' => 'entity_test_rev',
    ]);
    $entity->setName('view all revisions');
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', '- Restricted access -');
    $this->assertSession()
      ->elementTextNotContains('css', 'table tbody tr:nth-child(1)', $entity->getName());
  }
  
  /**
   * Test description with entity, without revision log, with label access.
   *
   * @legacy-covers ::getRevisionDescription
   */
  public function testDescriptionNoRevLogWithLabelAccess() : void {
    // Permission grants 'view label' access.
    $this->setCurrentUser($this->createUser([
      'view test entity',
    ]));
    /** @var \Drupal\entity_test\Entity\EntityTestRev $entity */
    $entity = EntityTestRev::create([
      'type' => 'entity_test_rev',
    ]);
    $entity->setName('view all revisions');
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', $entity->getName());
    $this->assertSession()
      ->elementTextNotContains('css', 'table tbody tr:nth-child(1)', '- Restricted access -');
  }
  
  /**
   * Test revision link, without access to revision page.
   *
   * @legacy-covers ::getRevisionDescription
   */
  public function testDescriptionLinkNoAccess() : void {
    /** @var \Drupal\entity_test_revlog\Entity\EntityTestWithRevisionLog $entity */
    $entity = EntityTestWithRevisionLog::create([
      'type' => 'entity_test_revlog',
    ]);
    $entity->setName('view all revisions');
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', 1);
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr a', 0);
  }
  
  /**
   * Test revision link, with access to revision page.
   *
   * Test two revisions. Usually the latest revision only checks canonical
   * route access, whereas all others will check individual revision access.
   *
   * @legacy-covers ::getRevisionDescription
   */
  public function testDescriptionLinkWithAccess() : void {
    /** @var \Drupal\entity_test_revlog\Entity\EntityTestWithRevisionLog $entity */
    $entity = EntityTestWithRevisionLog::create([
      'type' => 'entity_test_revlog',
    ]);
    // Revision has access to individual revision.
    $entity->setName('view all revisions, view revision');
    $entity->save();
    $firstRevisionId = $entity->getRevisionId();
    // Revision has access to canonical route.
    $entity->setName('view all revisions, view');
    $entity->setNewRevision();
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $row1Link = $this->assertSession()
      ->elementExists('css', 'table tbody tr:nth-child(1) a');
    $this->assertEquals($entity->toUrl()
      ->toString(), $row1Link->getAttribute('href'));
    // Reload revision so object has the properties to build a revision link.
    /** @var \Drupal\Core\Entity\RevisionableStorageInterface $storage */
    $storage = \Drupal::entityTypeManager()->getStorage('entity_test_revlog');
    $firstRevision = $storage->loadRevision($firstRevisionId);
    $row2Link = $this->assertSession()
      ->elementExists('css', 'table tbody tr:nth-child(2) a');
    $this->assertEquals($firstRevision->toUrl('revision')
      ->toString(), $row2Link->getAttribute('href'));
  }
  
  /**
   * Test revision log message if supported, and HTML tags are stripped.
   *
   * @legacy-covers ::getRevisionDescription
   */
  public function testDescriptionRevisionLogMessage() : void {
    /** @var \Drupal\entity_test_revlog\Entity\EntityTestWithRevisionLog $entity */
    $entity = EntityTestWithRevisionLog::create([
      'type' => 'entity_test_revlog',
    ]);
    $entity->setName('view all revisions');
    $entity->setRevisionLogMessage('<em>Hello</em> <script>world</script> <strong>123</strong>');
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    // Script tags are stripped, while admin-safe tags are retained.
    $this->assertSession()
      ->elementContains('css', 'table tbody tr:nth-child(1)', '<em>Hello</em> world <strong>123</strong>');
  }
  
  /**
   * Test revert operation.
   *
   * @legacy-covers ::buildRevertRevisionLink
   */
  public function testOperationRevertRevision() : void {
    /** @var \Drupal\entity_test_revlog\Entity\EntityTestWithRevisionLog $entity */
    $entity = EntityTestWithRevisionLog::create([
      'type' => 'entity_test_revlog',
    ]);
    $entity->setName('view all revisions');
    $entity->save();
    $entity->setName('view all revisions, revert');
    $entity->setNewRevision();
    $entity->save();
    $entity->setName('view all revisions, revert');
    $entity->setNewRevision();
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', 3);
    // Latest revision does not have revert revision operation: reverting latest
    // revision is not permitted.
    $row1 = $this->assertSession()
      ->elementExists('css', 'table tbody tr:nth-child(1)');
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', 'Current revision');
    $this->assertSession()
      ->elementNotExists('named', [
      'link',
      'Revert',
    ], $row1);
    // Revision 2 has revert revision operation: granted access.
    $row2 = $this->assertSession()
      ->elementExists('css', 'table tbody tr:nth-child(2)');
    $this->assertSession()
      ->elementExists('named', [
      'link',
      'Revert',
    ], $row2);
    // Revision 3 does not have revert revision operation: no access.
    $row3 = $this->assertSession()
      ->elementExists('css', 'table tbody tr:nth-child(3)');
    $this->assertSession()
      ->elementNotExists('named', [
      'link',
      'Revert',
    ], $row3);
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', 3);
  }
  
  /**
   * Test delete operation.
   *
   * @legacy-covers ::buildDeleteRevisionLink
   */
  public function testOperationDeleteRevision() : void {
    /** @var \Drupal\entity_test_revlog\Entity\EntityTestWithRevisionLog $entity */
    $entity = EntityTestWithRevisionLog::create([
      'type' => 'entity_test_revlog',
    ]);
    $entity->setName('view all revisions');
    $entity->save();
    $entity->setName('view all revisions, delete revision');
    $entity->setNewRevision();
    $entity->save();
    $entity->setName('view all revisions, delete revision');
    $entity->setNewRevision();
    $entity->save();
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', 3);
    // Latest revision does not have delete revision operation: deleting latest
    // revision is not permitted.
    $row1 = $this->assertSession()
      ->elementExists('css', 'table tbody tr:nth-child(1)');
    $this->assertSession()
      ->elementTextContains('css', 'table tbody tr:nth-child(1)', 'Current revision');
    $this->assertSession()
      ->elementNotExists('named', [
      'link',
      'Delete',
    ], $row1);
    // Revision 2 has delete revision operation: granted access.
    $row2 = $this->assertSession()
      ->elementExists('css', 'table tbody tr:nth-child(2)');
    $this->assertSession()
      ->elementExists('named', [
      'link',
      'Delete',
    ], $row2);
    // Revision 3 does not have delete revision operation: no access.
    $row3 = $this->assertSession()
      ->elementExists('css', 'table tbody tr:nth-child(3)');
    $this->assertSession()
      ->elementNotExists('named', [
      'link',
      'Delete',
    ], $row3);
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', 3);
  }
  
  /**
   * Test revisions are paginated.
   */
  public function testRevisionsPagination() : void {
    $this->installEntitySchema('entity_test_mulrev');
    /** @var \Drupal\entity_test\Entity\EntityTestMulRev $entity */
    $entity = EntityTestMulRev::create([
      'type' => 'entity_test_mulrev',
      'name' => 'view all revisions,view revision',
    ]);
    $entity->save();
    $firstRevisionId = $entity->getRevisionId();
    for ($i = 0; $i < VersionHistoryController::REVISIONS_PER_PAGE; $i++) {
      $entity->setNewRevision(TRUE);
      // We need to change something on the entity for it to be considered a new
      // revision to display. We need "view all revisions" and "view revision"
      // in a comma separated string to grant access.
      $entity->setName('view all revisions,view revision,' . $i)
        ->save();
    }
    // Create revisions without translation changes to ensure these do not
    // affect pagination.
    for ($i = 0; $i < VersionHistoryController::REVISIONS_PER_PAGE; $i++) {
      $entity->setNewRevision(TRUE);
      $entity->save();
    }
    $this->drupalGet($entity->toUrl('version-history'));
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', VersionHistoryController::REVISIONS_PER_PAGE);
    $this->assertSession()
      ->elementExists('css', '.pager');
    /** @var \Drupal\Core\Entity\RevisionableStorageInterface $storage */
    $storage = $this->container
      ->get('entity_type.manager')
      ->getStorage($entity->getEntityTypeId());
    $firstRevision = $storage->loadRevision($firstRevisionId);
    $secondRevision = $storage->loadRevision($firstRevisionId + 1);
    // We should see everything up to the second revision, but not the first.
    $this->assertSession()
      ->linkByHrefExists($secondRevision->toUrl('revision')
      ->toString());
    $this->assertSession()
      ->linkByHrefNotExists($firstRevision->toUrl('revision')
      ->toString());
    // The next page should show just the first revision.
    $this->resetPagerState();
    $this->clickLink('Go to next page');
    $this->assertSession()
      ->elementsCount('css', 'table tbody tr', 1);
    $this->assertSession()
      ->elementExists('css', '.pager');
    $this->assertSession()
      ->linkByHrefNotExists($secondRevision->toUrl('revision')
      ->toString());
    $this->assertSession()
      ->linkByHrefExists($firstRevision->toUrl('revision')
      ->toString());
  }
  
  /**
   * Resets pager manager state between requests.
   *
   * The PagerManager service persists maxPagerElementId across requests in
   * kernel tests, causing subsequent requests to use a different pager element
   * ID than expected. This makes the 'page' query parameter not correspond to
   * the correct pager element.
   *
   * @todo remove after https://www.drupal.org/project/drupal/issues/3609436
   */
  protected function resetPagerState() : void {
    $this->container
      ->set('pager.manager', new PagerManager($this->container
      ->get('pager.parameters')));
  }

}

Members

Title Sort descending Deprecated Modifiers Object type Summary Member alias Overriden Title Overrides
AssertContentTrait::$content protected property The current raw content.
AssertContentTrait::$drupalSettings protected property The drupalSettings value from the current raw $content.
AssertContentTrait::$elements protected property The XML structure parsed from the current raw $content.
AssertContentTrait::$plainTextContent protected property The plain-text content of raw $content (text nodes).
AssertContentTrait::assertEscaped protected function Passes if the raw text IS found escaped on the loaded page, fail otherwise.
AssertContentTrait::assertField protected function Asserts that a field exists with the given name or ID.
AssertContentTrait::assertFieldByName protected function Asserts that a field exists with the given name and value.
AssertContentTrait::assertFieldByXPath protected function Asserts that a field exists in the current page by the given XPath.
AssertContentTrait::assertFieldsByValue protected function Asserts that a field exists in the current page with a given Xpath result.
AssertContentTrait::assertLink protected function Passes if a link with the specified label is found.
AssertContentTrait::assertLinkByHref protected function Passes if a link containing a given href (part) is found.
AssertContentTrait::assertNoLink protected function Passes if a link with the specified label is not found.
AssertContentTrait::assertNoPattern protected function Triggers a pass if the perl regex pattern is not found in raw content.
AssertContentTrait::assertNoRaw protected function Passes if the raw text is NOT found on the loaded page, fail otherwise.
AssertContentTrait::assertNoText protected function Passes if the page (with HTML stripped) does not contains the text.
AssertContentTrait::assertPattern protected function Triggers a pass if the Perl regex pattern is found in the raw content.
AssertContentTrait::assertRaw protected function Passes if the raw text IS found on the loaded page, fail otherwise.
AssertContentTrait::assertText protected function Passes if the page (with HTML stripped) contains the text.
AssertContentTrait::assertTextHelper protected function Helper for assertText and assertNoText.
AssertContentTrait::assertThemeOutput protected function Asserts themed output.
AssertContentTrait::assertTitle protected function Pass if the page title is the given string.
AssertContentTrait::buildXPathQuery protected function Builds an XPath query.
AssertContentTrait::constructFieldXpath protected function Helper: Constructs an XPath for the given set of attributes and value.
AssertContentTrait::cssSelect protected function Searches elements using a CSS selector in the raw content.
AssertContentTrait::getAllOptions protected function Get all option elements, including nested options, in a select.
AssertContentTrait::getDrupalSettings protected function Gets the value of drupalSettings for the currently-loaded page.
AssertContentTrait::getRawContent protected function Gets the current raw content.
AssertContentTrait::getSelectedItem protected function Get the selected value from a select field.
AssertContentTrait::getTextContent protected function Retrieves the plain-text content from the current raw content.
AssertContentTrait::parse protected function Parse content returned from curlExec using DOM and SimpleXML.
AssertContentTrait::removeWhiteSpace protected function Removes all white-space between HTML tags from the raw content.
AssertContentTrait::setDrupalSettings protected function Sets the value of drupalSettings for the currently-loaded page.
AssertContentTrait::setRawContent protected function Sets the raw content (e.g. HTML).
AssertContentTrait::xpath protected function Performs an xpath search on the contents of the internal browser.
BrowserHtmlDebugTrait::$htmlOutputBaseUrl protected property The Base URI to use for links to the output files.
BrowserHtmlDebugTrait::$htmlOutputClassName protected property Class name for HTML output logging.
BrowserHtmlDebugTrait::$htmlOutputCounter protected property Counter for HTML output logging.
BrowserHtmlDebugTrait::$htmlOutputCounterStorage protected property Counter storage for HTML output logging.
BrowserHtmlDebugTrait::$htmlOutputDirectory protected property Directory name for HTML output logging.
BrowserHtmlDebugTrait::$htmlOutputEnabled protected property HTML output enabled.
BrowserHtmlDebugTrait::$htmlOutputTestId protected property HTML output test ID.
BrowserHtmlDebugTrait::formatHtmlOutputHeaders protected function Formats HTTP headers as string for HTML output logging.
BrowserHtmlDebugTrait::getHtmlOutputHeaders protected function Returns headers in HTML output format. 1
BrowserHtmlDebugTrait::getResponseLogHandler protected function Provides a Guzzle middleware handler to log every response received.
BrowserHtmlDebugTrait::getTestMethodCaller protected function Retrieves the current calling line in the class under test. 1
BrowserHtmlDebugTrait::htmlOutput protected function Logs a HTML output message in a text file.
BrowserHtmlDebugTrait::initBrowserOutputFile protected function Creates the directory to store browser output.
ConfigTestTrait::configImporter protected function Returns a ConfigImporter object to import test configuration.
ConfigTestTrait::copyConfig protected function Copies configuration objects from source storage to target storage.
DrupalTestCase::$root protected property The Drupal root directory.
DrupalTestCase::getDrupalRoot Deprecated protected function Returns the Drupal root directory. 1
DrupalTestCase::setUpRoot final protected function Ensure that the $root property is set initially.
DrupalTestCaseTrait::checkErrorHandlerOnTearDown public function Checks the test error handler after test execution. 1
DrupalTestCaseTrait::checkLegacySymfonyDeprecationHelperEnvVariable public function Checks legacy SYMFONY_DEPRECATIONS_HELPER env variable is not used.
DrupalTestCaseTrait::expectExceptionMessageIs protected function Expects an exactly matching exception message.
DrupalTestCaseTrait::expectExceptionMessageIsOrContains protected function Expects an exception message containing a specified string.
DrupalTestCaseTrait::setDebugDumpHandler public static function Registers the dumper CLI handler when the DebugDump extension is enabled.
ExtensionListTestTrait::getModulePath protected function Gets the path for the specified module.
ExtensionListTestTrait::getThemePath protected function Gets the path for the specified theme.
HttpKernelUiHelperTrait::$mink protected property Mink session manager.
HttpKernelUiHelperTrait::assertSession public function Returns WebAssert object.
HttpKernelUiHelperTrait::buildUrl protected function Builds a URL from a system path or a URL object.
HttpKernelUiHelperTrait::clickLink protected function Follows a link by complete name.
HttpKernelUiHelperTrait::drupalGet protected function Retrieves a Drupal path.
HttpKernelUiHelperTrait::getDefaultDriverInstance protected function Gets an instance of the default Mink driver.
HttpKernelUiHelperTrait::getNodeElementsByXpath protected function Performs an xpath search on the contents of the internal browser.
HttpKernelUiHelperTrait::getSession public function Returns Mink session.
HttpKernelUiHelperTrait::getUrl protected function Gets the current URL from the browser.
HttpKernelUiHelperTrait::initMink protected function Initializes Mink sessions.
HttpKernelUiHelperTrait::rebuildContainer protected function Rebuilds the container.
KernelTestBase::$classLoader protected property The class loader.
KernelTestBase::$configImporter protected property The configuration importer.
KernelTestBase::$configSchemaCheckerExclusions protected static property An array of config object names that are excluded from schema checking. 4
KernelTestBase::$container protected property The test container.
KernelTestBase::$databasePrefix protected property The test database prefix.
KernelTestBase::$keyValue protected property The key_value service that must persist between container rebuilds.
KernelTestBase::$siteDirectory protected property The relative path to the test site directory.
KernelTestBase::$strictConfigSchema protected property Set to TRUE to strict check all configuration saved. 9
KernelTestBase::$usesSuperUserAccessPolicy protected property Set to TRUE to make user 1 a super user. 1
KernelTestBase::$vfsRoot protected property The virtual filesystem root directory.
KernelTestBase::assertPostConditions protected function 1
KernelTestBase::bootEnvironment protected function Bootstraps a basic test environment.
KernelTestBase::bootKernel protected function Bootstraps a kernel for a test. 1
KernelTestBase::config protected function Configuration accessor for tests. Returns non-overridden configuration.
KernelTestBase::disableModules protected function Disables modules for this test.
KernelTestBase::enableModules protected function Enables modules for this test. 2
KernelTestBase::getConfigSchemaExclusions protected function Gets the config schema exclusions for this test.
KernelTestBase::getDatabaseConnectionInfo protected function Returns the Database connection info to be used for this test. 3
KernelTestBase::getDatabasePrefix public function Gets the database prefix used for test isolation.
KernelTestBase::getExtensionsForModules private function Returns Extension objects for $modules to install.
KernelTestBase::getModulesToEnable protected static function Returns the modules to install for this test.
KernelTestBase::initFileCache protected function Initializes the FileCache component.
KernelTestBase::installConfig protected function Installs default configuration for a given list of modules.
KernelTestBase::installEntitySchema protected function Installs the storage schema for a specific entity type.
KernelTestBase::installSchema protected function Installs database tables from a module schema definition.
KernelTestBase::register public function Registers test-specific services. Overrides ServiceProviderInterface::register 43
KernelTestBase::render protected function Renders a render array. 1
KernelTestBase::setInstallProfile protected function Sets the install profile and rebuilds the container to update it.
KernelTestBase::setSetting protected function Sets an in-memory Settings variable.
KernelTestBase::setUpFilesystem protected function Sets up the filesystem, so things like the file directory. 3
KernelTestBase::tearDown protected function 11
KernelTestBase::tearDownCloseDatabaseConnection public function Additional tear down method to close the connection at the end.
KernelTestBase::vfsDump protected function Dumps the current state of the virtual filesystem to STDOUT.
KernelTestBase::__sleep public function Prevents serializing any properties.
RandomGeneratorTrait::getRandomGenerator protected function Gets the random generator for the utility methods.
RandomGeneratorTrait::randomMachineName protected function Generates a unique random string containing letters and numbers.
RandomGeneratorTrait::randomObject public function Generates a random PHP object.
RandomGeneratorTrait::randomString public function Generates a pseudo-random string of ASCII characters of codes 32 to 126.
RevisionVersionHistoryTest::$modules protected static property Modules to install. Overrides KernelTestBase::$modules
RevisionVersionHistoryTest::resetPagerState protected function Resets pager manager state between requests.
RevisionVersionHistoryTest::setUp protected function Overrides KernelTestBase::setUp
RevisionVersionHistoryTest::testCurrentRevision public function Test current revision is indicated.
RevisionVersionHistoryTest::testDescriptionLinkNoAccess public function Test revision link, without access to revision page.
RevisionVersionHistoryTest::testDescriptionLinkWithAccess public function Test revision link, with access to revision page.
RevisionVersionHistoryTest::testDescriptionNoRevLogNoLabelAccess public function Test description with entity, without revision log, no label access.
RevisionVersionHistoryTest::testDescriptionNoRevLogWithLabelAccess public function Test description with entity, without revision log, with label access.
RevisionVersionHistoryTest::testDescriptionRevisionLogMessage public function Test revision log message if supported, and HTML tags are stripped.
RevisionVersionHistoryTest::testDescriptionRevLog public function Test description with entity implementing revision log.
RevisionVersionHistoryTest::testDescriptionRevLogNullValues public function Test description with entity implementing revision log, with empty values.
RevisionVersionHistoryTest::testOperationDeleteRevision public function Test delete operation.
RevisionVersionHistoryTest::testOperationRevertRevision public function Test revert operation.
RevisionVersionHistoryTest::testOrder public function Test all revisions appear, in order of revision creation.
RevisionVersionHistoryTest::testRevisionsPagination public function Test revisions are paginated.
StorageCopyTrait::replaceStorageContents protected static function Copy the configuration from one storage to another and remove stale items.
UserCreationTrait::checkPermissions protected function Checks whether a given list of permission names is valid.
UserCreationTrait::createAdminRole protected function Creates an administrative role.
UserCreationTrait::createRole protected function Creates a role with specified permissions.
UserCreationTrait::createUser protected function Create a user with a given set of permissions. Aliased as: drupalCreateUser 1
UserCreationTrait::grantPermissions protected function Grant permissions to a user role.
UserCreationTrait::setCurrentUser protected function Switch the current logged in user.
UserCreationTrait::setUpCurrentUser protected function Creates a random user account and sets it as current user.

Buggy or inaccurate documentation? Please file an issue. Need support? Need help programming? Connect with the Drupal community.